#!/bin/bash

#script permettant la mise en place de wsusoffline sur le se4fs, sa maj et le lancement par tache cron des maj Windows dans le répertoire /var/sambaedu/unnattended/install/wsusoffline.

#les variables

recup_conf()
{
# variables ou fonctions sambaedu à récupérer des fichiers de configuration
. /usr/share/sambaedu/includes/config.inc.sh

# On vérifie qu le fichier de conf existe
if [ -e "/etc/sambaedu/sambaedu.conf.d/wsusoffline.conf" ] ;
        then
                echo "fichier de conf  /etc/sambaedu/sambaedu.conf.d/wsusoffline.conf déjà présent, on ne modifie rien"
        else
               set_config wsusoffline rep_wsus "/var/sambaedu/unattended/install/wsusoffline"
               set_config wsusoffline fichier_cron "/etc/cron.d/sambaedu-wsusoffline"
               set_config wsusoffline url_wsus "https://deb.sambaedu.org/wsusoffline"
               set_config wsusoffline version_wsus "126"
               set_config wsusoffline fichier_log  "/var/sambaedu/unattended/install/wsusoffline/log/wsus.log"
               set_config wsusoffline envoi_mail "yes"
               set_config wsusoffline version_win "w100-x64"
               set_config wsusoffline lang_win "fra"
               chown www-admin:root /etc/sambaedu/sambaedu.conf.d/wsusoffline.conf
               chmod 700 /etc/sambaedu/sambaedu.conf.d/wsusoffline.conf

fi

#lecture des paramètres sambaedu.conf
. /usr/share/sambaedu/includes/config.inc.sh
get_config
}

################################################################################# Les fonctions de base ##############################################################################################

test_installation_precedente()
{
#On regarde si wsusoffline est déjà installé sur le serveur, avec la bonne version
#On compare le fichier version_locale de wsusoffline avec celui du dépot. S'ils sont différents, alors on relance la fonction installation_wsusoffline: la nouvelle archive sera dl et mise en place.
version_locale=$(cat "${config_rep_wsus}"/version_locale.txt)


if  [ $version_locale = $config_version_wsus ] ;
        then 
echo "Il y a déjà une version locale sur le se4fs qui est est la même que celle indiquée sur le fichier de configuration, on arrête le script"
        exit
        else
echo "Pas de version déjà installée, ou version sur le se4fs différente de celle indiquée dans le fichier de configuration. On continue l'installation."
fi
}

test_repertoire()
{
#On teste la présence du répertoire wsusoffline car celui-ci doit être présent lors de la récupération des archives.
if [ -e "$config_rep_wsus" ] ;
        then
        echo "répertoire $config_rep_wsus déjà présent"
        else
        mkdir -p "$config_rep_wsus"
fi
}
recup_latest()
{
#On récupère le fichier latest.txt pour trouver quelle est la dernière version disponible sur le serveur sambaedu.
wget -P ${config_rep_wsus} -O ${config_rep_wsus}/latest.txt -q --show-progress ${config_url_wsus}/latest.txt
latest=$(cat "${config_rep_wsus}"/latest.txt)
echo "Pour information:"
echo "La dernière version disponible de wsusoffline est la version \"$latest\", il suffit de remplacer la version dans le fichier /etc/sambaedu/sambaedu.conf.d/wsusoffline.conf pour que la mise à jour se fasse automatiquement."
echo ""

}


recup_infos_archive()
{
echo "récupération des informations de l'archive wsusoffline à partir du serveur $config_url_wsus"
#On supprime les informations de l'archive précédente au cas où...
rm -f ${config_rep_wsus}/version_online.txt
rm -f ${config_rep_wsus}/latest.txt


if [ $config_version_wsus = 120 ] || [ $config_version_wsus = 1191 ] ;
        then
wget -P ${config_rep_wsus} -O ${config_rep_wsus}/version_online.txt -q --show-progress ${config_url_wsus}/wsusoffline"$config_version_wsus"_hashes.txt
        else
wget -P ${config_rep_wsus} -O ${config_rep_wsus}/version_online.txt -q --show-progress ${config_url_wsus}/wsusofflineCE"$config_version_wsus"_hashes.txt
fi

#Le fichier récupéré a probablement été fait sous Windows, il faut donc supprimer les caractères sauts de ligne avec "tr -d '\r\n'"
filename=$(cat "${config_rep_wsus}/version_online.txt" |sed "1,2d"|cut -d ',' -f5 | tr -d '\r\n')
md5_archive=$(cat ${config_rep_wsus}/version_online.txt |sed '1,2d' |cut -d ',' -f2| tr -d '\r\n')
echo "voici le nom du fichier :$filename"
echo "voici le md5 de l'archive $md5_archive"
}


recup_archive()
{

echo "récupération du fichier archive wsusoffline $config_url_wsus/$filename"
wget -P ${config_rep_wsus} -O  $config_rep_wsus/$filename --show-progress $config_url_wsus/$filename

}

extraction_archive()
{

#On vérifie que l'archive téléchargée  a bien le bon hash md5
md5_local=$(md5sum  $config_rep_wsus/$filename| cut -d ' ' -f1)
if  [ $md5_local != $md5_archive ] ;
        then 
echo "fichier $filename est corrompu  (md5local est $md5_local alors que celui du dépot est $md5_archive : il faut vérifier le proxy système. "
echo "relancez le script après avoir reglé le soucis: vous pouvez tester en lançant la commande "wget --show-progress $config_url_wsus/$filename" "
exit

        else
unzip -d $config_rep_wsus/.. -o $config_rep_wsus/$filename

#On écrit la version de l'archive  dézzipée pour savoir quand mettre wsusoffline à jour sur le serveur.
echo $config_version_wsus > ${config_rep_wsus}/version_locale.txt
#une fois extraie, on supprime l'archive
rm -f  $config_rep_wsus/$filename

fi

}


droits_wsus()
{
#Pour que domain computer puisse lire/executer le client sur les postes, il faut modifier les droits du répertoire wsusoffline.
chown -R www-admin:domain\ admins $config_rep_wsus
#modifs droits pour rapports wsusoffline
chown -R www-admin:domain\ admins /var/sambaedu/unattended/install/wpkg/rapports
}



cron_wsus()
{
#mise en place d'une tache cron pour le dl quotidien des maj windows et pour le check de la version de wsusoffline.
#Si un fichier /etc/crontab.d/sambaedu-wsus existe déjà (ou a été modifié), on ne fait rien.
#CETTE PARTIE DOIT ETRE LANCEE EN ROOT POUR ECRIRE DANS 
if [ -e "$config_fichier_cron" ] ;
    then
        echo "Le fichier $config_fichier_cron est déjà présent ou a été édité, on n'y touche pas!"
    else

cat <<EOF>> $config_fichier_cron

# On teste si des maj wsusoffline sont disponibles
# A partir de 20h45 UTC+2, afin de correspondre avec l'heure de mise en ligne
# des maj Micosoft a 18h UTC
45 20  * * *   root /usr/share/sambaedu/scripts/wsusoffline.sh --maj-win >/dev/null 2>&1

# # On teste si des maj du programme wsusoffline sont disponibles
15 20  * * *   root /usr/share/sambaedu/scripts/wsusoffline.sh --maj-wsus >/dev/null 2>&1

EOF

fi
}

envoi_mail_post_dl()
{
        if [ "$config_envoi_mail" = "yes" ] ;
                then
contenu=$(cat $config_fichier_log)
sujet="Subject: Compte-rendu Wsusoffline "
echo "$sujet $contenu" | msmtp root
                else
echo "Pas de mail à  envoyer à root@se4fs d'après le fichier de configuration."

        fi

}

############################################################## FONCTIONS PRINCIPALES ###################################################################################


installation_wsusoffline()
{
recup_conf
test_installation_precedente
recup_infos_archive
recup_archive
extraction_archive
#cron_wsus
droits_wsus
}
nettoyage_wsus()
{
#On supprime tout l'ancien dispositif
rm -Rf /var/sambaedu/unattended/install/wsusoffline/*
}

maj_wsusoffline()
{
#On force le changement des archives wsusoffline pour prendre l'adresse du serveur sambaedu.org
set_config wsusoffline url_wsus "https://deb.sambaedu.org/wsusoffline"
recup_latest
#On recharge la conf
recup_conf
recup_infos_archive
#On compare le fichier version_locale de wsusoffline avec celui du dépot. S'ils sont différents, alors on relance la fonction installation_wsusoffline: la nouvelle archive sera dl et mise en place.
version_locale=$(cat "${config_rep_wsus}"/version_locale.txt)

#On récupère la version désirée par l'utilisateur dans le fichier de conf. La valeur de $config_version_wsus est donc écrasée.

if  [ $version_locale = $config_version_wsus ] ;
        then 
echo "La version locale sur le se4fs est la même que celle disponible sur le serveur SambaÉdu"
        else
echo "La version installée n'est pas la même que celle disponible sur le serveur download.wsusoffline.net: on installe la nouvelle version."
nettoyage_wsus
installation_wsusoffline

fi
}


dl_maj_win()
{
recup_conf

echo "Pour vérification: version(s) de Windows/office à prendre en charge: $config_version_win"
echo "Pour vérification: Langage(s) de Windows à prendre en charge: $config_lang_win"

date  > $config_fichier_log
recup_latest

if  [ $latest = $config_version_wsus ] ;
        then 
echo "Vous disposez bien de la dernière version de Wsusoffline présente sur le serveur SambaÉdu." >> $config_fichier_log
        else
echo "La dernière version disponible de Wsusoffline sur le serveur SambaÉdu est la version \"$latest\",actuellement la version \"$config_version_wsus\" est en place. Il suffit de remplacer la version dans le fichier /etc/sambaedu/sambaedu.conf.d/wsusoffline.conf pour que la mise à jour se fasse automatiquement." >> $config_fichier_log

fi

sudo -u www-admin bash $config_rep_wsus/sh/download-updates.bash $config_version_win $config_lang_win -includecpp -includedotnet -includewddefs >> $config_fichier_log
droits_wsus
envoi_mail_post_dl
}
